Public Member Functions | Data Fields

# GoalListWindow Struct Reference

Inheritance diagram for GoalListWindow:

## Public Member Functions
| GoalListWindow (const WindowDesc *desc, WindowNumber window_number)
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
void | HandleClick (const Goal *s)
uint | CountLines ()
| Count the number of lines in this window.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
void | DrawPartialGoalList (int &pos, const int cap, int x, int y, int right, bool global_section) const
| Draws either the global goals or the company goal section.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Data Fields
Scrollbar * | vscroll

## Detailed Description

Definition at line 29 of file goal_gui.cpp.

## Member Function Documentation

uint GoalListWindow::CountLines | ( |  | ) | `[inline]`

Count the number of lines in this window.

Returns:
  the number of lines

Definition at line 114 of file goal_gui.cpp.

References _local_company, Goal::company, and INVALID_COMPANY.

Referenced by OnInvalidateData().

void GoalListWindow::DrawPartialGoalList | ( | int & | pos,
|  | const int | cap,
|  | int | x,
|  | int | y,
|  | int | right,
|  | bool | global_section |
| ) |  |  | const`[inline]`

Draws either the global goals or the company goal section.

This is a helper method for DrawWidget.

Definition at line 153 of file goal_gui.cpp.

References _local_company, Goal::company, DrawString(), FONT_HEIGHT_NORMAL, INVALID_COMPANY, IsInsideMM(), SetDParamStr(), and Goal::text.

Referenced by DrawWidget().

virtual void GoalListWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 178 of file goal_gui.cpp.

References _date, ConvertDateToYMD(), DrawPartialGoalList(), Scrollbar::GetCapacity(), Scrollbar::GetPosition(), and WID_GL_PANEL.

virtual void GoalListWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 40 of file goal_gui.cpp.

References _local_company, Goal::company, Scrollbar::GetScrolledRowFromWidget(), INVALID_COMPANY, WD_FRAMERECT_TOP, and WID_GL_PANEL.

virtual void GoalListWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 210 of file goal_gui.cpp.

References CountLines(), and Scrollbar::SetCount().

virtual void GoalListWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 200 of file goal_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_GL_PANEL.

virtual void GoalListWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 136 of file goal_gui.cpp.

References GetStringBoundingBox(), maxdim(), WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, and WID_GL_PANEL.

The documentation for this struct was generated from the following file:

- src/goal_gui.cpp